rm(list = ls())
#setwd("/Users/kseniak/Documents/Ksenia_CalibrationSystems/Code")

load("Model1_data.Rda")

theta.true = c(19, 6)
n.samples = 10^5
theta.smpls = mat.or.vec(n.samples + 1,2)
theta.smpls[1,] = as.vector(summary(lm(y~x,data = Model1_data))$coefficients[,1])
sigma.sq.smpls = mat.or.vec(n.samples,1)

for (i in 1:n.samples) {
  sigma.sq.smpls[i] = 1/rgamma(1,dim(Model1_data)[1]/2,(sum((Model1_data[,2]-theta.smpls[i,1] - theta.smpls[i,2]*Model1_data[,1])^2)/2));  
  
  theta.smpls[i + 1,1] = rnorm(1,mean(Model1_data[,2]) - theta.smpls[i,2]*mean(Model1_data[,1]), sqrt(sigma.sq.smpls[i]/dim(Model1_data)[1]))
  
  theta.smpls[i + 1,2] = rnorm(1,sum((Model1_data[,2] - theta.smpls[i + 1,1])*Model1_data[,1])/sum(Model1_data[,1]^2), sqrt(sigma.sq.smpls[i]/sum(Model1_data[,1]^2)))
}
theta.smpls = theta.smpls[-1,]
x1.test <- seq(0,1,length = 100)
y1.test = mat.or.vec(n.samples,length(x1.test))
# and here is the inferential one, which we are going to use # 
for (i in 1:dim(y1.test)[2]) {for (j in 1:dim(y1.test)[1]) {y1.test[j,i] <- theta.smpls[j,1]+theta.smpls[j,2]*x1.test[i]}}
NGaSP.inv <- list(x = x1.test,mu = apply(y1.test,2,mean), var = diag(apply(y1.test,2,var)),q1 = apply(y1.test,2,quantile,0.025),q2 = apply(y1.test,2,quantile,0.975))

par(mfrow = c(1,2))
plot(density(theta.smpls[,1]),xlab = expression(theta[1]),main = "")
plot(density(theta.smpls[,2]),xlab = expression(theta[2]),main = "")

par(mfrow = c(1,1))
par(mar=c(6.0, 6.0, 6.0, 6.0), mgp=c(3, 1, 0), las=0)
plot(x1.test,NGaSP.inv$mu,xlab = expression(x[1]),type = "l",col = "gold", 
     ylab = expression(y[1]),cex.lab = 2,cex.axis = 1.3,lwd = 2)
lines(x1.test,NGaSP.inv$mu + qnorm(0.025)*sqrt(diag(NGaSP.inv$var)),type = "l",col = "darkgrey",lwd = 2)
lines(x1.test,NGaSP.inv$mu + qnorm(0.975)*sqrt(diag(NGaSP.inv$var)),type = "l",col = "darkgrey",lwd = 2)

points(Model1_data[,1],Model1_data[,2],pch = 20,col = "black")
legend("topleft", c("Predicted mean", "Approx. 95%-CIs", "Observed data"),lty = c(rep(1,2),NA),lwd = c(rep(2,2),NA),pch = c(rep(NA,2),20),col = c("gold","darkgrey","black"),bty = "n")

f<-function(x1,x2,om1,om2,y1){x2*exp(-x1/y1)*cos(om1*x1 + om2)}
design = read.csv("design.csv",sep = ",")
test_design = read.csv("test_design.csv",sep = ",")

library(LinkedGASP)
M2.data2.training <- list(training = as.matrix(design[,2:6]), fD = as.matrix(design[,7]), smooth = rep(2,5))
ptm <- proc.time()
MLEs.data2 = eval_GASP_RFP(M2.data2.training,list(),1:5,TRUE)
ptm <- proc.time() - ptm
#function(x){x[,1]^0},function(x){x[,1]},function(x){x[,2]},function(x){x[,5]}
TGaSP_M2.data2 <- eval_TGASP(as.matrix(test_design[,2:6]),MLEs.data2)
par(mfrow = c(1,2))
plot(TGaSP_M2.data2$mu,test_design[,7]);abline(0,1,col = "gold")
plot(TGaSP_M2.data2$mu,diag(TGaSP_M2.data2$sigma))

TGASPmetrics(TGaSP_M2.data2,test_design[,7],mean(design[,7]))
em = eval_type2_GASP(as.matrix(test_design[,2:6]),MLEs.data2)
par(mfrow = c(1,2))
plot(em$mu,as.matrix(as.matrix(test_design[,7])));abline(0,1,col = "gold")
plot(em$mu,sqrt(diag(em$var)))

NGASPmetrics(em,test_design[,7],mean(design[,7]))

## Two emulators have been trained ##
#### now I want to link the second emulator with the already linked one ####

## Calibration data ## Assuming here perfect data
# om.true = c(5,pi*9/10) # point-wise true
# load("CalibrationData.Rda")
# This data is generated assuming omega follows some true distribution rather than being a point-wise value.
load("CalibrationDataOmegaDistrs.Rda")

y1.calibr <- mat.or.vec(dim(theta.smpls)[1],length(x1.calibr))
for (i in 1:dim(y1.calibr)[2]) {for (j in 1:dim(theta.smpls)[1]) {y1.calibr[j,i] <- theta.smpls[j,1]+theta.smpls[j,2]*x1.calibr[i];}}

NGaSP <- list(x = x1.calibr,mu = apply(y1.calibr,2,mean), var = diag(apply(y1.calibr,2,var)),q1 = apply(y1.calibr,2,quantile,0.025),q2 = apply(y1.calibr,2,quantile,0.975))

s_f2 = cbind(mat.or.vec(length(NGaSP$mu),4),NGaSP$mu)
s.var_f2 = cbind(mat.or.vec(length(NGaSP$mu),4),diag(NGaSP$var))

linkWdistrs<-function(s, s.var, MLEs, test_input, link_input_nums) {
  library(spBayes)
  my_input = as.matrix(MLEs$data$training)
  nolink_rest_nums = which(!(1:length(MLEs$delta))%in%link_input_nums)
  betaM = exp(MLEs$delta)
  integr = 1
  corr.fun <- function(training,delta,smooth) {exp(-exp(delta)*(iDist(training))^smooth)}
  cor = matrix(1,dim(my_input)[1],dim(my_input)[1])
  for (i in link_input_nums) {
    integr = integr*exp(-betaM[i]*t(outer(my_input[,i],s[,i],"-"))^2/(1 + 2*s.var[,i]*betaM[i]))/sqrt(1+2*s.var[,i]*betaM[i])
    cor = cor*corr.fun(my_input[,i],MLEs$delta[i],MLEs$data$smooth[i])
  }
  for (i in nolink_rest_nums) {
    integr = integr*exp(-betaM[i]*t(abs(outer(my_input[,i],test_input[,i],"-")))^MLEs$data$smooth[i])
    cor = cor*corr.fun(my_input[,i],MLEs$delta[i],MLEs$data$smooth[i])
  }
  nu = exp(MLEs$eta)/(1 + exp(MLEs$eta))
  cor = cor + nu*diag(dim(my_input)[1])
  q <- length(MLEs$basis)
  a = as.vector(solve(cor,MLEs$data$fD))
  mu = integr%*%a
  g = solve(cor)
  v = rep(0,length(mu))
  sigmaT = rep(0,length(mu))
  for (i in 1:length(v)) {
    mat = 1
    for (j in link_input_nums) {
      mat = mat*exp(-2*betaM[j]*(outer(my_input[,j],my_input[,j],"+")/2-s[i,j])^2/(1 + 4*s.var[i,j]*betaM[j])-betaM[j]*outer(my_input[,j],my_input[,j],"-")^2/2)/
        sqrt(1+4*s.var[i,j]*betaM[j])
    }
    for (j in nolink_rest_nums) {
      mat = mat*exp(-betaM[j]*outer(abs(my_input[,j]-test_input[i,j])^MLEs$data$smooth[j],abs(my_input[,j]-test_input[i,j])^MLEs$data$smooth[j],"+"))
    }
    v[i] = MLEs$sigma.sq*(1 + nu - sum(g*mat)) + sum(outer(a,a,"*")*mat)
    #v[i] = v[i] + 2*MLEs$beta[4]*sum(integr[i,]*a*(2*betaM[5]*s.var[i,5]*my_input[,5] + s[i,5])/(1 + 2*s.var[i,5]*betaM[5]))
    sigmaT[i] = as.numeric(-t(MLEs$data$fD)%*%(-g)%*%MLEs$data$fD)/(dim(my_input)[1]-2)*(1 + sum((-g)*mat) + nu) + sum(outer(a,a,"*")*mat)
  }
  #beta0 = cbind(rep(1,dim(s)[1]),test_input[,1],test_input[,2])%*%MLEs$beta[1:3,]
  #v = v + (beta0)^2 + 2*beta0*MLEs$beta[4]*s[,5] + MLEs$beta[4]^2*(s.var[,5] + s[,5]^2) +
  # 2*beta0*integr%*%a - mu^2
  v = v - mu^2
  if (sum(v<0)>0) print("Oops")
  v = as.vector(v*as.numeric(v>=0))
  comb.em1 = list(mu = as.vector(mu), var = diag(as.vector(v)))
  #analytical form for variance of the T-GaSP
  
  sigmaT = as.vector(sigmaT - mu^2)
  sigmaT = sigmaT*as.numeric(sigmaT>=0)
  comb.em3 = list(mu = as.vector(mu), var = diag(as.vector(sigmaT)))
  comb.emT = list(mu = as.vector(mu), sigma = diag(as.vector(sigmaT)),df = dim(my_input)[1])
  ## Since we have zero-mean, there are no beta parameters to account for uncertainty, so em2 becomes the same as em1 ##
  return(list(em1 = comb.em1, em2 = comb.em1, em3 = comb.em3, emT = comb.emT))
}
#### Now calibrate omega #### 
om1 = seq(1,10,0.1)
om2 = seq(0,pi,pi/100)

om1 = seq(4,6.5,length = 50)
om2 = seq(2.2,pi,length = 50)

omGrid = expand.grid(om1,om2)
omPosterior = rep(0,dim(omGrid)[1])
for (i in 1:dim(omGrid)[1]) {
  gem <- linkWdistrs(s_f2,s.var_f2,MLEs.data2,cbind(x1.calibr,x2.calibr,rep(omGrid[i,1],length(x1.calibr)),rep(omGrid[i,2],length(x1.calibr)),rep(0,length(x1.calibr))),link_input_nums = 5)
  omPosterior[i] <- sum(dnorm(y.true, gem$emT$mu, sqrt(diag(gem$emT$sigma)*gem$emT$df/(gem$emT$df - 2)), log = TRUE))
  if (i%%100 == 0) print(i)
}

omProb = matrix(omPosterior,ncol = length(om2),nrow = length(om1),byrow = FALSE)
probs = exp(omProb)/sum(exp(omProb))
library(lattice)
contour(x = om1, y = om2, z = probs, levels = seq(max(probs)/10,max(probs),by = max(probs)/5),
        cex = 2)

par(mar=c(6.0, 6.0, 4.1, 2.1), mgp=c(3, 1, 0), las=0)

# In case of the point-wise true omega, set om.true[1] and om.true[2]
filled.contour(x = om1, y= om2,z = probs,col = c("white","gray83","gray72","gray61","grey50","grey39","grey17","black"),nlevels = 8,
               plot.axes={axis(1); axis(2);points(om.true[,1],om.true[,2],pch = 19,col = "gold")},
               xlab=expression(omega[1]),ylab= expression(omega[2]), cex.lab = 2)

filled.contour(x = om1, y= om2, z = probs,cols = c("white","gray83","gray72","gray61","grey50","grey39","grey28","black"),nlevels = 8,
               plot.axes={axis(1); axis(2);points(om.true[,1],om.true[,2],pch = 19,col = "gold")},
               key.title=filled.contour(x = om1, y = om2, z = probsTrue,col = adjustcolor(c("white","blanchedalmond","bisque1","sandybrown","tan1","tan2","tan3","tan4")),nlevels = 8),xlab=expression(omega[1]),ylab= expression(omega[2]), cex.lab = 2)


library(tmvtnorm)
omTrueDistr = dmvnorm(omGrid,c(5,pi*9/10),Sigma.cov, log = TRUE) ### True distribution of omega
omProbTrue = matrix(omTrueDistr,ncol = length(om2),nrow = length(om1),byrow = FALSE)
probsTrue = exp(omProbTrue)/sum(exp(omProbTrue))

#### Plot of the true density
filled.contour(x = om1, y = om2, z = probsTrue, col = c("white","grey87","grey77","grey67","grey57","grey44","grey35","grey21","black"),nlevels = 8,
               plot.axes={axis(1); axis(2);points(om.true[1],om.true[2],pch = 19,col = "gold")},
               xlab=expression(omega[1]),ylab= expression(omega[2]), cex.lab = 2)

library(rgl)

x1 = seq(0,1,by = 0.01)
x2 = seq(0,1,by = 0.01)*5+1
x.gr = expand.grid(x1,x2)

y1 <- mat.or.vec(dim(theta.smpls)[1],length(x1))
for (i in 1:length(x1)) {for (j in 1:dim(theta.smpls)[1]) {y1[j,i] <- theta.smpls[j,1]+theta.smpls[j,2]*x1[i];}}

NGaSP <- list(x = x1,mu = apply(y1,2,mean), var = diag(apply(y1,2,var)))

s_f2 = cbind(mat.or.vec(length(NGaSP$mu)*length(x2),4),rep(NGaSP$mu,length(x2)))
s.var_f2 = cbind(mat.or.vec(length(NGaSP$mu)*length(x2),4),rep(diag(NGaSP$var),length(x2)))

om.hp = as.matrix(omGrid[which.max(omPosterior),])
gem <- linkWdistrs(s_f2,s.var_f2,MLEs.data2,cbind(x.gr[,1],x.gr[,2],rep(om.hp[1],dim(x.gr)[1]),rep(om.hp[2],dim(x.gr)[1]),rep(0,dim(x.gr)[1])),link_input_nums = 5)

#### Account for uncertainty in the posterior estimates of parameters omega
s_f2 = cbind(mat.or.vec(length(NGaSP$mu)*length(x2),2),
             rep(sum(omGrid[,1]*exp(omPosterior)/sum(exp(omPosterior))),length(x2)),
             rep(sum(omGrid[,2]*exp(omPosterior)/sum(exp(omPosterior))),length(x2)),
             rep(NGaSP$mu,length(x2)))
s.var_f2 = cbind(mat.or.vec(length(NGaSP$mu)*length(x2),2),
                 rep(sum((omGrid[,1] - s_f2[1,3])^2*exp(omPosterior)/sum(exp(omPosterior))),length(x2)),
                 rep(sum((omGrid[,2] - s_f2[1,4])^2*exp(omPosterior)/sum(exp(omPosterior))),length(x2)),
                 rep(diag(NGaSP$var),length(x2)))
gem <- linkWdistrs(s_f2,s.var_f2,MLEs.data2,cbind(x.gr,rep(0,dim(x.gr)[1]),rep(0,dim(x.gr)[1]),rep(0,dim(x.gr)[1])),
                   link_input_nums = 3:5)

z.v = matrix(gem$em2$mu, ncol = length(x2), nrow = length(x1))
sd.v = matrix(sqrt(diag(gem$em2$var)), ncol = length(x2), nrow = length(x1))
persp3d(x1,x2,z.v + 1.96*sd.v,aspect = c(1, 1, 1), col = "darkgrey", alpha = 0.33, lit = T, shininess = 35,back="lines",xlab = expression(x[1]),ylab = expression(x[2]),zlab = "y")
persp3d(x1,x2,z.v - 1.96*sd.v,aspect = c(1, 1, 1), col = "darkgrey", alpha = 0.33, lit = T, shininess = 35,front = "lines", add = T)
points3d(x1.calibr,x2.calibr,y.true,size = 4,col = "forestgreen",cex = 2)



y1 <- mat.or.vec(dim(theta.smpls)[1],length(x1.calibr))
for (i in 1:length(x1.calibr)) {for (j in 1:dim(theta.smpls)[1]) {y1[j,i] <- theta.smpls[j,1]+theta.smpls[j,2]*x1.calibr[i];}}

NGaSP <- list(x = x1.calibr,mu = apply(y1,2,mean), var = diag(apply(y1,2,var)))

s_f2 = cbind(mat.or.vec(length(NGaSP$mu),2),
             rep(sum(omGrid[,1]*exp(omPosterior)/sum(exp(omPosterior))),length(x2.calibr)),
             rep(sum(omGrid[,2]*exp(omPosterior)/sum(exp(omPosterior))),length(x2.calibr)),
             NGaSP$mu)
s.var_f2 = cbind(mat.or.vec(length(NGaSP$mu),2),
                 rep(sum((omGrid[,1] - s_f2[1,3])^2*exp(omPosterior)/sum(exp(omPosterior))),length(x2.calibr)),
                 rep(sum((omGrid[,2] - s_f2[1,4])^2*exp(omPosterior)/sum(exp(omPosterior))),length(x2.calibr)),
                 diag(NGaSP$var))
gem <- linkWdistrs(s_f2,s.var_f2,MLEs.data2,cbind(x1.calibr,x2.calibr,rep(0,length(x2.calibr)),
                                                  rep(0,length(x2.calibr)),rep(0,length(x2.calibr))),
                   link_input_nums = 3:5)
plot(gem$em1$mu,y.true);abline(0,1,col = "green")
plot(sqrt(diag(gem$em1$var)))
NGASPmetrics(gem$em1,y.true,mean(y.true))
