rm(list = ls())
## load("Model1_data.Rda")
## below is original code to generate the data
theta.true = c(19, 6)
x = sample(seq(0,1,length = 10000),11)
y = rnorm(length(x),theta.true[1] + theta.true[2]*x,0.2)
Model1_data = data.frame(cbind(x,y))

## design = read.csv("design.csv",sep = ",")
## test_design = read.csv("test_design.csv",sep = ",")
## below is original code to generate the data
library(DiceDesign)
dimension = 5;nruns = 50
design <- lhsDesign(nruns,dimension)$design
design <- maximinSA_LHS(design,T0=10,c=0.99,it=100)
plot(design$design[,4])
plot(design$critValues,type="l")
plot(design$tempValues,type="l")

design = design$design

design[,2] = design[,2]*5 + 1 # X2
design[,3] = design[,3]*9 + 1 # omega_1
design[,4] = design[,4]*pi # omega_2

y1 <- mat.or.vec(dim(theta.smpls)[1],length(design[,1]))
for (i in 1:dim(y1)[2]) {for (j in 1:dim(theta.smpls)[1]) {y1[j,i] <- theta.smpls[j,1]+theta.smpls[j,2]*design[i,1]}}
design[,5] = mapply(quantile,data.frame(y1),design[,5]) # Y_1

design = cbind(1:nruns,design)

f<-function(x1,x2,om1,om2,y1){x2*exp(-x1/y1)*cos(om1*x1 + om2)}
design = cbind(design,f(design[,2],design[,3],design[,4],design[,5],design[,6]))

# par(mfrow= c(2,3))
# plot(design[,2],design[,7])
# plot(design[,3],design[,7])
# plot(design[,4],design[,7])
# plot(design[,5],design[,7])
# plot(design[,6],design[,7])
# plot(design[,1],design[,7])

write.table(design,file = "design.csv",col.names = c("Run","X1", "X2","omega_1","omega_2","Y_1","Output"), row.names = FALSE, sep = ",")
## analogously run this code second time to get test design
# test_design = design 
# write.table(test_design,file = "test_design.csv",col.names = c("Run","X1", "X2","omega_1","omega_2","Y_1","Output"), row.names = FALSE, sep = ",")

## Calibration data ## Assuming here perfect data
## load("CalibrationData.Rda")
## below is original code to generate the data
library(DiceDesign)
design <- lhsDesign(20,2)$design
design <- maximinSA_LHS(design,T0=10,c=0.99,it=100)
plot(design$design[,4])
plot(design$critValues,type="l")
plot(design$tempValues,type="l")

design = design$design

x1.calibr <- design[,1]
x2.calibr <- design[,2]*5 + 1
y1.true = theta.true[1] + theta.true[2]*x1.calibr
om.true = c(5,pi*9/10)
y.true <- f(x1.calibr,x2.calibr,om.true[1],om.true[2],y1.true)

## Calibration data ## Assuming here that omega is not a point-wise truth, but indeed a bivariate random variable with some distribution. I will put a bivariate normal distribution for simplicity.
## load("CalibrationData.Rda")
## below is original code to generate the data
library(DiceDesign)
n_cal_pts = 20
design <- lhsDesign(n_cal_pts,2)$design
design <- maximinSA_LHS(design,T0=10,c=0.99,it=100)
plot(design$design[,4])
plot(design$critValues,type="l")
plot(design$tempValues,type="l")

design = design$design

x1.calibr <- design[,1]
x2.calibr <- design[,2]*5 + 10
y1.true = theta.true[1] + theta.true[2]*x1.calibr
library(tmvtnorm)
Sigma.cov = matrix(c(0.1^2,rep(-0.6*0.1*0.05,2),0.05^2),ncol = 2)
om.true = rmvnorm(n_cal_pts,c(5,pi*9/10),Sigma.cov)
y.true <- f(x1.calibr,x2.calibr,om.true[,1],om.true[,2],y1.true)
