#### create 2 input dimensions ####
rm(list = ls())
#install.packages("LinkedGASP")
library(LinkedGASP) #lsf.str("package:LinkedGASP")
#my_input = expand.grid(c(1,3,log(seq(exp(5),exp(10),length.out = 4))),seq(0.05,1,by = 0.18))
my_input = expand.grid(seq(1,10,by = 3),seq(0.05,1,by = 0.18))
corr.columns = 1:2
p=length(corr.columns)

b0<-function(x){x[,1]^0}
b1<-function(x){x[,2]}

basis = list(b0,b1)

f<-function(om,x){exp(-x)*cos(om*x)}

my_output = f(my_input[,1],my_input[,2])
setwd("/Users/kseniak/Documents/Ksenia_CalibrationSystems/Code")

#source("GaSP.R")
data <- list(training = my_input, fD= my_output, smooth = rep(2,2))

ptm1 <- proc.time()
MLEs = eval_GASP_RFP(data,basis,corr.columns,FALSE)
ptm1 <- proc.time() - ptm1

test_input = as.data.frame(cbind(c(2.5,8.5,5.5,2.5,8.5),c(rep(0.14,2),0.5,rep(0.86,2))))
test_output = f(test_input[,1],test_input[,2])

par(mar=c(5.1, 5.5, 4.1, 2.1), mgp=c(3, 1, 0), las=0)
plot(NA,xlim = c(0,1),ylim = c(0,11),xaxt = "n",yaxt = "n",
     ylab = expression(omega), xlab = "t",cex.lab = 1.9)
points(my_input[,2],my_input[,1],pch = 19, col = "gold",cex = 2)
points(test_input[,2],test_input[,1],pch = "*", col = "forestgreen",
       cex = 3)
axis(1, at=unique(my_input[,2]),cex.axis = 1.5)
axis(2, at=unique(my_input[,1]),cex.axis = 1.5)

#TGASP <- eval_TGASP(test_input,MLEs)
NGASP <- eval_type2_GASP(test_input,MLEs)
plot(eval_TGASP(test_input,MLEs)$mu,test_output);abline(0,1, col = "forestgreen")
#sqrt(diag(eval_TGASP(test_input,MLEs)$sigma))
#sqrt(diag(eval_type2_GASP(test_input,MLEs)$var))
#char.length = exp(-MLEs$delta/MLEs$data$smooth) #range parameter
#nugget = exp(MLEs2$eta)
MLEs$beta
beta
MLEs$delta
delta
exp(MLEs$eta)/(1+exp(MLEs$eta))
nu
MLEs$sigma.sq
sigma.sq

NGASPmetrics(NGASP,test_output,mean(my_output))

library(rgl)
x.v = seq(1,10,by = 0.09)
y.v = seq(0.05,1,by = 0.01)
gr.v = expand.grid(x.v,y.v)
em = eval_type2_GASP(gr.v,MLEs)
z.v = matrix(em$mu, ncol = length(y.v), nrow = length(x.v))
sd.v = matrix(sqrt(diag(em$var)), ncol = length(y.v), nrow = length(x.v))
persp3d(x.v,y.v,z.v + 1.96*sd.v,aspect = c(1, 1, 1), col = "darkgrey", alpha = 0.33, lit = T, shininess = 35,back="lines",xlab = expression(omega),ylab = "t",zlab = "y")
persp3d(x.v,y.v,z.v - 1.96*sd.v,aspect = c(1, 1, 1), col = "darkgrey", alpha = 0.33, lit = T, shininess = 35,front = "lines", add = T)
#points3d(test_input[,1],test_input[,2],test_output,size = 10,col = "forestgreen",cex = 2)
points3d(my_input[,1],my_input[,2],my_output,size = 10,col = "gold",cex = 2)

# lines <- contourLines(x.v, y.v, z.v) 
# for (i in seq_along(lines)) { 
#   x <- lines[[i]]$x 
#   y <- lines[[i]]$y 
#   z <- rep(lines[[i]]$level, length(x)) 
#   lines3d(x, y, z) 
# } 

####
omg = 5.0104
gasp <- eval_type2_GASP(data.frame(cbind(rep(omg,101),seq(0,1,0.01))),MLEs)

#### Second example ####
gasp <- eval_type2_GASP(data.frame(cbind(rep(5,3),c(0.1,0.7,0.75))),MLEs)

#### 
#### This function is to plot the GASP with multi-dimensional input in a particular direction. 
GaSP_plot_axisDir <- function(em, fun, input.dir, data, emul_type, labels, ylab, xlab,ylim,col_CI_area,col_points,col_fun,col_mean,x.experim,y.experim) {
  library(tmvtnorm)
  xax = unique(data$training[,input.dir])
  if (missing(x.experim)) {
    x.experim = xax
  }
  if (missing(y.experim)) {
    y.experim = fun(x.experim)
  }
  if(missing(col_CI_area)) {
    col_CI_area = "lightgreen"
  }
  if(missing(col_points)) {
    col_points = "darkorchid"
  }
  if(missing(col_fun)) {
    col_fun = "navajowhite"
  }
  if(missing(col_mean)) {
    col_mean = "darkgreen"
  }
  if(missing(labels)) {
    labels <- xax
  }  
  if(missing(xlab)) {
    xlab <- "y, input"
  }
  if(missing(ylab)) {
    ylab <- "g, output"
  }
  input = em$x[,input.dir]; var = diag(em$var)
  smpl = rmvnorm(1,em$mu,em$var)
  #smpl = rnorm(length(input),em$mu,sqrt(diag(em$var)))
  ql = em$mu + qnorm(.025,0,1)*sqrt(var)
  qu = em$mu + qnorm(.975,0,1)*sqrt(var)
  f.values = fun(input)
  coverage = f.values <= qu & f.values >= ql
  if (any(coverage == FALSE)) {
    for (i in which(coverage == FALSE)) {
      coverage[i] = all.equal(f.values[i],ql[i])==TRUE || all.equal(f.values[i],qu[i])==TRUE
    }
  }
  emp.coverage = sum(coverage)/length(f.values)
  if (missing(ylim)) ylim = range(f.values,ql,qu)
  plot(input,ql,type = "l", col = col_CI_area, ylab = "", xlab = "",ylim = ylim, xaxt = "n", yaxt = "n")
  par(new = TRUE)
  plot(input,qu,type = "l", col = col_CI_area, ylab = "", xlab = "",ylim = ylim, xaxt = "n", yaxt = "n")
  polygon(c(input,rev(input)),c(qu,rev(ql)),col=col_CI_area,border = NA)
  
  # par(new = TRUE)
  # plot(input,em$mu,type = "l",lty = 1, col=col_mean, lwd = 3, ylab = "",xlab ="",ylim = ylim, xaxt = "n", yaxt = "n")
  par(new = TRUE)
  # plot(input,f.values,type = "l", lty = 1,col = col_fun, lwd = 3, ylab = "", xlab = "",ylim = ylim, xaxt = "n", yaxt = "n")
  # par(new = TRUE)
  plot(input,smpl,type = "l", lty = 1,col = col_mean, lwd = 3, ylab = "", xlab = "",ylim = ylim, xaxt = "n", yaxt = "n")
  par(new = TRUE)
  
  #points(x.experim,y.experim,pch = 20,col = col_points,cex = 2.5)
  axis(1, at=xax, labels=labels, cex.axis = 1.5)
  axis(2, cex.axis = 1.5)
  
  yl = deparse(ylab)
  # legend("topright", lty = 1, lwd = 3, cex = 1.4,
  #        bty = "n",
  #        legend = c("True function"),
  #        col = c(col_fun))
  
  # legend("topright",lty = c(rep(1,1),NA),pch=c(rep(NA,1),20),lwd = rep(3,1),cex = 1.4,
  #        bty = "n",
  #        legend = c("True function","Experimental"),
  #        col = c(col_fun,col_points))
  
  legend("topright",lty = rep(1,2),lwd = rep(3,2),cex = 1.4,
         bty = "n",
         legend = c("Sample","95%-CI area"),
         col = c(col_mean,col_CI_area))
  
  
  # legend("topright",lty = c(rep(1,3),NA),pch=c(rep(NA,3),20),lwd = rep(3,3),cex = 1.4,
  #        bty = "n",
  #        legend = c("True function","Emulator mean","95%-CI area","Experimental"),
  #        col = c(col_fun,col_mean,col_CI_area,col_points))
  title(main = "",ylab = ylab, xlab = xlab,cex.lab = 2, mgp=c(3,1,.5))
  #text(sum(range(input))/2,ylim[1],bquote(paste("Emp. coverage "==.(round(emp.coverage,4)*100),"%")))
  par(new = FALSE)
}

#### Plot GASP in the direction of the second input, while the first input is fixed at the value of omega set at omg.
GaSP_plot_axisDir(gasp,function(x){f(omg,x)},2,data,"Type 2 GASP",
                  xlab = "t", ylab = "y",ylim = c(-1,1.5),
                  x.experim = t.experim,y.experim = y.experim,col_fun = "darkorchid")

#### Removing correlation structure
gasp$cor = diag(diag(gasp$cor)) # leave only diagonal elements, others are set to zeros
gasp$var = diag(diag(gasp$var)) # leave only diagonal elements, others are set to zeros

GaSP_plot_axisDir(gasp,function(x){f(omg,x)},2,data,"Type 2 GASP",
                  xlab = "t", ylab = "y",ylim = c(-1,1.5),
                  x.experim = t.experim,y.experim = y.experim,col_fun = "darkorchid")

#experimental observations - noiseless
library(tmvtnorm)
t.experim = c(0.1,0.7,0.75)
t.experim = c(0.1,0.95,0.53,0.36,0.7,0.23,0.83) 
t.experim = c(0.10000000000000000555112, 0.94999999999999995559108, 0.53000000000000002664535,
0.35999999999999998667732, 0.69999999999999995559108, 0.23000000000000000999201,
0.82999999999999996003197, 0.10565981624631089197397, 0.96184524328700438111639,
0.54910614806746749216870, 0.36342651125762859276591, 0.69069440888366728792391,
0.22153204700605227950305, 0.82257654783091038730447, 0.10099776258064226130973,
0.93232077840597293860725, 0.53814341715209579319890, 0.35400650149447754344578,
0.08967551408410380509029, 0.94347886370473599271236, 0.54689406303706511458529)
ptm.om <- proc.time()
omGrid = seq(1,10,0.0001)
y.true = f(5,t.experim)
omProb = matrix(NA,length(omGrid),1)
omProbT = matrix(NA,length(omGrid),1)
for (i in 1:length(omGrid)) {
  gem <- eval_type2_GASP(data.frame(cbind(rep(omGrid[i],length(t.experim)),t.experim)),MLEs)
  omProb[i] <- exp(sum(dnorm(y.true, gem$mu, sqrt(diag(gem$var)), log = TRUE)))
  omProbT[i] <- exp(dmvnorm(y.true, gem$mu, gem$var, log = TRUE))
  if(!i%%100) print(i)
}
gem <- eval_type2_GASP(data.frame(cbind(rep(5,length(t.experim)),t.experim)),MLEs)
cov2cor(gem$var)
omProb = rowMeans(omProb)
omProbT = rowMeans(omProbT)
omProbT = omProbT/sum(omProbT)
omProb = omProb/sum(omProb)
ylim = c(0,max(omProb,omProbT)) #c(0,0.019) #
plot(omGrid,omProbT, type = "l", ylab = "Posterior density", xlab = expression(omega),
     xaxt = "n",ylim = ylim,col = "forestgreen", lwd = 3,cex.lab = 1.9,cex.axis = 1.5)
lines(omGrid,omProb, type = "l", col = "orange", lwd = 3, lty = 2)
axis(1, at = c(1,4,7,10),cex.axis = 1.5)
points(5,0,col = "forestgreen", pch = "*", cex = 1.9)
axis(1,at = 5, col = "forestgreen",cex.axis = 1.5)
#text(8, ylim[2]/2, bquote(sigma == .(wn.sd)))
legend("topright", legend = c("True", "Approx."), col = c("forestgreen","orange"), lty = c(1,2), lwd = rep(3,2),bty = "n")

cdfPost = cumsum(omProb)
omGrid[which(cdfPost>0.025)[1]]
omGrid[rev(which(cdfPost<0.975))[1]]

corr.fun <- function(training1, training2, delta,
smooth) {
if (missing(training2))
exp(-exp(delta) * (iDist(training1))^smooth)
else exp(-exp(delta) * (iDist(training1, training2))^smooth)
}

corr.fun(t.experim,delta = MLEs$delta[2], smooth = MLEs$data$smooth[2])
####
library(invgamma)
x = t.experim
t.experim = rep(x, each = 2) #c(0.1, rep(0.7, 2), 0.75) #
groups = rep(1:3,each = 2) #c(1,rep(2,2),3) 
wn.sd = 0.02
y.true = f(5,x)
y.experim = f(5,t.experim) + rnorm(length(t.experim),0,wn.sd)

n.smpls = 1000
var.smpls = rep(NA,n.smpls + 1)
mu.smpls = matrix(NA,3,n.smpls)

alp = length(t.experim)/2
#### initialize the Gibbs sampling with an educated guess ####
var.smpls[1] = abs(diff((y.experim[groups == 2])[1:2])/2)^2
for (smpl in 1:n.smpls) {
  for (group in 1:3) {
    mu.smpls[group,smpl] = rnorm(1,sum(y.experim[groups == group])/sum(groups == group),
                                 sqrt(var.smpls[smpl]/sum(groups == group)))
  }
  bet = sum((y.experim - mu.smpls[groups,smpl])^2)/2 ## inverse scale parameter
  var.smpls[smpl + 1] = rinvgamma(1,shape = alp, rate = bet) #1/rgamma(1,alp,1/bet)
}
var.smpls = var.smpls[2:length(var.smpls)] ## delete the starting value

par(mfrow = c(2,2))
plot(mu.smpls[1,],type = "l",ylab = expression(mu[1]),xlab = "",cex.lab = 1.9);abline(h = y.true[1],col = "green")
plot(mu.smpls[2,],type = "l",ylab = expression(mu[2]),xlab = "",cex.lab = 1.9);abline(h = y.true[2],col = "green")
plot(mu.smpls[3,],type = "l",ylab = expression(mu[3]),xlab = "",cex.lab = 1.9);abline(h = y.true[3],col = "green")
plot(var.smpls,type = "l",xlab = "", ylab = expression(sigma^2),cex.lab = 1.9);abline(h = wn.sd^2,col = "green")

omGrid = seq(1,10,0.01)

omProb = matrix(NA,length(omGrid),n.smpls)
omProbT = matrix(NA,length(omGrid),n.smpls)
for (i in 1:length(omGrid)) {
  gem <- eval_type2_GASP(data.frame(cbind(rep(omGrid[i],length(x)),x)),MLEs)
  for (j in 1:n.smpls) {
    omProb[i,j] <- exp(sum(dnorm(mu.smpls[,j], gem$mu, sqrt(diag(gem$var)), log = TRUE)))
    omProbT[i,j] <- exp(dmvnorm(mu.smpls[,j], gem$mu, gem$var, log = TRUE))
  }
  if(!i%%100) print(i)
}
omProb = rowMeans(omProb)
omProbT = rowMeans(omProbT)
omProbT = omProbT/sum(omProbT)
omProb = omProb/sum(omProb)
ylim = c(0,0.019) #c(0,max(omProb,omProbT))
par(mfrow = c(1,1))
plot(omGrid,omProbT, type = "l", ylab = "", xlab = "",
     xaxt = "n",yaxt = "n",ylim = ylim,col = "forestgreen", lwd = 3,cex.lab = 1.9)
lines(omGrid,omProb, type = "l", col = "orange", lwd = 3, lty = 2)
axis(1, at = c(1,4,7,10), cex.axis = 1.5)
axis(2, cex.axis = 1.4)
points(5,0,col = "forestgreen", pch = "*", cex = 2.5)
axis(1,at = 5, col = "forestgreen",cex.lab = 1.5, cex.axis = 1.5)
text(8, ylim[2]/2, bquote(sigma == .(wn.sd)),cex = 1.5)
legend("topright", legend = c("True", "Approx."), col = c("forestgreen","orange"), lty = c(1,2), lwd = rep(3,2),bty = "n",cex = 1.4)
title(main = "",ylab = "Posterior density", xlab = expression(omega),cex.lab = 2, mgp=c(3,1,.5))

### points(t.experim,f(5,t.experim), col = "darkorchid", pch = 19)
### GASP_plot(gasp,function(x){f(5,x)},data,"Type 2 GASP",
###          xlab = "t", ylab = "y", ylim = c(-1,1.5))
####

x = c(0.1,0.7,0.75)
t.experim = rep(x, 2) #c(0.1, rep(0.7, 2), 0.75) #
groups = rep(1:3,2) #c(1,rep(2,2),3) 
wn.sd = 0.04
y.true = f(5,x)
r = 0.7
#SGM = matrix(c(1,0,0,0,1,r,0,r,1),ncol = 3)
SGM = matrix(c(1,r,r,r,1,r,r,r,1),ncol = 3)
SGM = rbind(cbind(SGM,0*SGM),cbind(0*SGM,SGM))
#SGM = rbind(cbind(SGM,0*SGM,0*SGM),cbind(0*SGM,SGM,0*SGM),cbind(0*SGM,0*SGM,SGM))
y.experim = f(5,t.experim) + rmvnorm(1,rep(0,length(t.experim)),wn.sd^2*SGM)

n.smpls = 1000
var.smpls = rep(NA,n.smpls + 1)
mu.smpls = matrix(NA,3,n.smpls)

alp = length(t.experim)/2
#### initialize the Gibbs sampling with an educated guess ####
var.smpls[1] = abs(diff((y.experim[groups == 2])[1:2])/2)^2
for (smpl in 1:n.smpls) {
  for (group in 1:3) {
    mu.smpls[group,smpl] = rnorm(1,sum(y.experim[groups == group])/sum(groups == group),
                                 sqrt(var.smpls[smpl]/sum(groups == group)))
  }
  bet = c((y.experim - mu.smpls[groups,smpl])%*%solve(SGM,t(y.experim - mu.smpls[groups,smpl])))/2 ## inverse scale parameter
  var.smpls[smpl + 1] = rinvgamma(1,shape = alp, rate = bet) #1/rgamma(1,alp,1/bet)
}
var.smpls = var.smpls[2:length(var.smpls)] ## delete the starting value

par(mfrow = c(2,2))
plot(mu.smpls[1,],type = "l",ylab = expression(mu[1]),xlab = "",cex.lab = 1.9);abline(h = y.true[1],col = "green")
plot(mu.smpls[2,],type = "l",ylab = expression(mu[2]),xlab = "",cex.lab = 1.9);abline(h = y.true[2],col = "green")
plot(mu.smpls[3,],type = "l",ylab = expression(mu[3]),xlab = "",cex.lab = 1.9);abline(h = y.true[3],col = "green")
plot(var.smpls,type = "l",xlab = "", ylab = expression(sigma^2),cex.lab = 1.9);abline(h = wn.sd^2,col = "green")

omGrid = seq(1,10,0.01)

omProb = matrix(NA,length(omGrid),n.smpls)
omProbT = matrix(NA,length(omGrid),n.smpls)
for (i in 1:length(omGrid)) {
  gem <- eval_type2_GASP(data.frame(cbind(rep(omGrid[i],length(x)),x)),MLEs)
  for (j in 1:n.smpls) {
    omProb[i,j] <- exp(sum(dnorm(mu.smpls[,j], gem$mu, sqrt(diag(gem$var)), log = TRUE)))
    omProbT[i,j] <- exp(dmvnorm(mu.smpls[,j], gem$mu, gem$var, log = TRUE))
  }
  if(!i%%100) print(i)
}
omProb = rowMeans(omProb)
omProbT = rowMeans(omProbT)
omProbT = omProbT/sum(omProbT)
omProb = omProb/sum(omProb)
ylim = c(0,0.019) #c(0,max(omProb,omProbT))
par(mfrow = c(1,1))
plot(omGrid,omProbT, type = "l", ylab = "", xlab = "",
     xaxt = "n",yaxt = "n",ylim = ylim,col = "forestgreen", lwd = 3,cex.lab = 1.9)
lines(omGrid,omProb, type = "l", col = "orange", lwd = 3, lty = 2)
axis(1, at = c(1,4,7,10), cex.axis = 1.5)
axis(2, cex.axis = 1.4)
points(5,0,col = "forestgreen", pch = "*", cex = 2.5)
axis(1,at = 5, col = "forestgreen",cex.lab = 1.5, cex.axis = 1.5)
text(8, ylim[2]/2, bquote(sigma == .(wn.sd)),cex = 1.5)
legend("topright", legend = c("True", "Approx."), col = c("forestgreen","orange"), lty = c(1,2), lwd = rep(3,2),bty = "n", cex = 1.4)
title(main = "",ylab = "Posterior density", xlab = expression(omega),cex.lab = 2, mgp=c(3,1,.5))

####


gem <- eval_type2_GASP(data.frame(cbind(rep(omGrid[which.max(omProb)],3),t.experim)),MLEs)

par(mfrow = c(1,1))
plot(gasp$x[,2],f(5,gasp$x[,2]),col = "darkorchid",ylab = "y, output",xlab="x, input", ylim = c(-1,1), main = "Predicted output from the emulator", type = "l")

par(mfrow = c(1,1))
plot(gasp$x[,2],gasp$mu,col = "orange",ylab = "y, output",xlab="x, input", ylim = c(-1,1), main = "Predicted output from the emulator", type = "l")
lines(gasp$x[,2],gasp$mu + qnorm(0.025)*sqrt(diag(gasp$var)),ylab = "", xlab = "", col = "forestgreen")
lines(gasp$x[,2],gasp$mu + qnorm(0.975)*sqrt(diag(gasp$var)),ylab = "", xlab = "", col = "forestgreen")
points(t.experim,y.true[,1])
legend("topleft", c("Predicted mean", "Approx. 95%-CIs", "Observed output"),lty = c(rep(1,2),NA),pch = c(rep(NA,2),1),col = c("orange","forestgreen","black"),bty = "n")

fun_plot <- function(x, y, xlab, ylab, ylim) {
  if(missing(xlab)) {
    xlab <- "x"
  }
  if(missing(ylab)) {
    ylab <- "f(x)"
  }
  if (missing(linked)) {
    true_name = paste("true ", ylab)
  } else true_name = expression("true g" ~ scriptscriptstyle(O) ~ "f")
  input = em$x; var = diag(em$var)
  ql = em$mu + qnorm(.025,0,1)*sqrt(var)
  qu = em$mu + qnorm(.975,0,1)*sqrt(var)
  f.values = fun(input)
  coverage = f.values <= qu & f.values >= ql
  if (any(coverage == FALSE)) {
    for (i in which(coverage == FALSE)) {
      coverage[i] = all.equal(f.values[i],ql[i])==TRUE || all.equal(f.values[i],qu[i])==TRUE
    }
  }
  emp.coverage = sum(coverage)/length(f.values)
  if (missing(ylim)) ylim = range(f.values,ql,qu)
  plot(input,em$mu,type = "l",col="blue",ylab = "",xlab ="",ylim = ylim, xaxt = "n")
  par(new = TRUE)
  plot(input,f.values,type = "l", col = "red", ylab = "", xlab = "",ylim = ylim, xaxt = "n")
  par(new = TRUE)
  plot(input,ql,type = "l", col = "black", lty = 2,ylab = "", xlab = "",ylim = ylim, xaxt = "n")
  par(new = TRUE)
  plot(input,qu,type = "l", col = "black", lty = 2,ylab = "", xlab = "",ylim = ylim, xaxt = "n")
  axis(1, at=xax, labels=labels,cex.lab = 1.5)
  points(xax,fun(xax))
  yl= deparse(ylab)
  legend("topleft",lty=c(1,1,2),lwd = rep(2,3),
         bty = "n",
         #legend = c(true_name,"GASP mean","95%-CIs"),
         legend = c(expression("true"~f[a](x)),"GASP mean","95%-CIs"),
         col = c("red","blue","black"))
  #title(main = emul_type,ylab = ylab, xlab = xlab,cex.lab = 1.9,mgp=c(2,1,.5))
  title(main = "",ylab = expression(f[a](x)), xlab = xlab,cex.lab = 1.9)
  #text(sum(range(input))/2,min(em$mu,f.values),bquote(paste("Emp. coverage "==.(round(emp.coverage,4)*100),"%")))
  par(new = FALSE)
}
